# IO.Swagger - the C# library for the &lt;PBXDom API&gt;


This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.1.0
- SDK version: 1.0.0
- Build date: 2016-06-25T14:19:12.262Z
- Build package: class io.swagger.codegen.languages.CSharpClientCodegen

## Frameworks supported
- .NET 4.0 or later
- Windows Phone 7.1 (Mango)

## Dependencies
- [RestSharp] (https://www.nuget.org/packages/RestSharp) - 105.1.0 or later
- [Json.NET] (https://www.nuget.org/packages/Newtonsoft.Json/) - 7.0.0 or later

The DLLs included in the package may not be the latest version. We recommned using [NuGet] (https://docs.nuget.org/consume/installing-nuget) to obtain the latest version of the packages:
```
Install-Package RestSharp
Install-Package Newtonsoft.Json
```

NOTE: RestSharp versions greater than 105.1.0 have a bug which causes file uploads to fail. See [RestSharp#742](https://github.com/restsharp/RestSharp/issues/742)

## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh build.sh`
- [Windows] `build.bat`

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using Model;
```

## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using Model;

namespace Example
{
    public class Example
    {
        public void main()
        {
            
            var apiInstance = new DefaultApi();
            var rptType = 1.2;  // double? | Report type. (0 report, 1 widget, 2 chart).
            var rptId = 1.2;  // double? | Report id.
            var start = 3.4;  // decimal? | Start offset. (optional) 
            var limit = 3.4;  // decimal? | Number of results to return. Max 10K. (optional) 
            var sortBy = sortBy_example;  // string | Sort column. (optional) 
            var sortType = sortType_example;  // string | Sort mode asc/desc. (optional) 
            var fromDate = fromDate_example;  // string | Start date time. (optional) 
            var toDate = toDate_example;  // string | End date time. (optional) 
            var duration = 3.4;  // decimal? | Duration range. (optional) 
            var phone = phone_example;  // string | List of caller phone. (optional) 
            var phone1 = phone1_example;  // string | List of dialled phones. (optional) 
            var co = co_example;  // string | List of trunk/co. (optional) 
            var ext = ext_example;  // string | list of extensions. (optional) 
            var pbxId = 3.4;  // decimal? | list of PBX Ids. (optional) 
            var callSource = 3.4;  // decimal? | list of callsource. (optional) 
            var callType = 3.4;  // decimal? | list of call type signatures.(5 Unanswered Calls, 7 Transfered Calls, 8 Forwarded Calls) (optional) 
            var direction = 3.4;  // decimal? | list of direction.(0 incoming, 1 outgoing, 2 internal) (optional) 
            var callerName = callerName_example;  // string | list of caller name. (optional) 
            var did = did_example;  // string | list of did. (optional) 
            var dnis = dnis_example;  // string | list of dnis. (optional) 
            var acc = acc_example;  // string | list of account code. (optional) 
            var ring = 3.4;  // decimal? | Ring range.Seconds unit. (optional) 
            var cost = 3.4;  // decimal? | Cost range. (optional) 
            var group = 3.4;  // decimal? | Department/Group id. (optional) 

            try
            {
                List<InlineResponse200> result = apiInstance.CallsGet(rptType, rptId, start, limit, sortBy, sortType, fromDate, toDate, duration, phone, phone1, co, ext, pbxId, callSource, callType, direction, callerName, did, dnis, acc, ring, cost, group);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.CallsGet: " + e.Message );
            }
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://api.pbxdom.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**CallsGet**](docs/DefaultApi.md#callsget) | **GET** /Calls | 
*DefaultApi* | [**FeaturesChartsGet**](docs/DefaultApi.md#featureschartsget) | **GET** /Features/charts | 
*DefaultApi* | [**FeaturesReportsGet**](docs/DefaultApi.md#featuresreportsget) | **GET** /Features/reports | 
*DefaultApi* | [**FeaturesWidgetGet**](docs/DefaultApi.md#featureswidgetget) | **GET** /Features/widget | 


## Documentation for Models

 - [Model.InlineResponse200](docs/InlineResponse200.md)


## Documentation for Authorization

 All endpoints do not require authorization.

